<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Cryptocurrency Chart with Traders</title>
    <link href="https://cdn.jsdelivr.net/npm/tailwindcss@2.2.19/dist/tailwind.min.css" rel="stylesheet">
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.6.0/dist/jquery.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
    <style>
    @font-face {
    font-family: 'IRANSansWeb';
    src: url('IRANSansWeb.ttf') format('truetype');
    font-weight: normal;
    font-style: normal;
}

        body {
    background: linear-gradient(180deg, #1e3a8a, #111827);
    color: white;
    font-family: 'IRANSansWeb', Arial, sans-serif;
    direction: rtl; /* اگر زبان سایت فارسی است */
    margin: 0;
    padding: 0;
    display: flex;
    background-repeat: no-repeat;
    flex-direction: row;
    flex-wrap: wrap;
    align-content: center;
    justify-content: space-evenly;
    align-items: center;
        }
        #top-section {
    height: 60vh;
    width: 49.3%;
    display: flex;
    flex-direction: row-reverse;
    align-items: center;
    justify-content: space-evenly;
    padding: 3px;
    box-sizing: border-box;
    margin-top: 99px;
    flex-wrap: wrap;
    align-content: stretch;
    
        }
        #tradingview-widget {
            width: 100%;
            height: 100%;
            border-radius: 10px;
            overflow: hidden;
            background: #121212;
        }
        #bottom-section {
            height: 59.4vh;
            width: 49%;
            padding: 20px;
            box-sizing: border-box;
            margin-top: 99px;
            background: #121212;
            border-radius: 10px;
            overflow-y: scroll;
            margin-right: 4px;
            direction: rtl;
        }
        
#bottom-section {
  --sb-track-color: #232E33;
  --sb-thumb-color: #0077bd;
  --sb-size: 6px;
}

#bottom-section::-webkit-scrollbar {
  width: var(--sb-size)
}

#bottom-section::-webkit-scrollbar-track {
  background: var(--sb-track-color);
  border-radius: 3px;
}

#bottom-section::-webkit-scrollbar-thumb {
  background: var(--sb-thumb-color);
  border-radius: 3px;
  border: 2px solid #0077bd;
}

@supports not selector(::-webkit-scrollbar) {
  #bottom-section {
    scrollbar-color: var(--sb-thumb-color)
                     var(--sb-track-color);
  }
}
#news-container {
  --sb-track-color: #232E33;
  --sb-thumb-color: #0077bd;
  --sb-size: 6px;
}

#news-container::-webkit-scrollbar {
  width: var(--sb-size)
}

#news-container::-webkit-scrollbar-track {
  background: var(--sb-track-color);
  border-radius: 3px;
}

#news-container::-webkit-scrollbar-thumb {
  background: var(--sb-thumb-color);
  border-radius: 3px;
  border: 2px solid #0077bd;
}

@supports not selector(::-webkit-scrollbar) {
  #news-container {
    scrollbar-color: var(--sb-thumb-color)
                     var(--sb-track-color);
  }
}
    #btm-section {
    height: 55.7vh;
    width: 49%;
    display: flex;
    flex-direction: row-reverse;
    align-items: center;
    justify-content: space-evenly;
    padding: 20px;
    box-sizing: border-box;
    /* border-bottom: 2px solid rgba(255, 255, 255, 0.2); */
    flex-wrap: wrap;
    align-content: stretch;
    background: #121212;
    border-radius: 10px;
    margin-bottom:30px;
    overflow: hidden;
    
        }
.btm2-section {
    height: 55.7vh;
    width: 49%;
    padding: 20px;
    box-sizing: border-box;
    background: #121212;
    border-radius: 10px;
    margin-bottom: 30px;
    direction: rtl;
    overflow-y: scroll;
    margin-left: -5px;
  }
  .btm2-section {
  --sb-track-color: #232E33;
  --sb-thumb-color: #0077bd;
  --sb-size: 6px;
}

.btm2-section::-webkit-scrollbar {
  width: var(--sb-size)
}

.btm2-section::-webkit-scrollbar-track {
  background: var(--sb-track-color);
  border-radius: 3px;
}

.btm2-section::-webkit-scrollbar-thumb {
  background: var(--sb-thumb-color);
  border-radius: 3px;
  border: 2px solid #0077bd;
}

@supports not selector(::-webkit-scrollbar) {
  .btm2-section {
    scrollbar-color: var(--sb-thumb-color)
                     var(--sb-track-color);
  }
}
        .autocomplete-suggestions {
    position: absolute;
    background: #2a2a2a;
    border-radius: 5px;
    z-index: 1000;
    width: 15%;
    max-height: 200px;
    overflow-y: auto;
    color: white;
    box-shadow: 0 0 9px 3px #007bff;
    background-color: #393939;
    margin-left: 560px;
    line-height: 40px;
    padding-right: 10px;
    margin-top: 120px;
        }
        .top-bar {
            position: absolute;
            top: 0;
            width: 100%;
            z-index: 10;
            padding: 10px;
            background: rgba(0, 0, 0, 0.8);
            display: flex;
            flex-wrap: wrap;
            justify-content: center;
            align-items: center;
            border-bottom: 1px solid rgba(255, 255, 255, 0.2);
        }
        .top-bar input, .top-bar select, .top-bar button {
            margin: 5px;
        }
        .top-bar input, .top-bar select {
            width: 20%;
            padding: 10px;
            border: none;
            border-radius: 5px;
            background: #2a2a2a;
            color: white;
            box-shadow: inset 0 0 5px rgba(255, 255, 255, 0.2);
        }
        .top-bar button {
            padding: 10px 20px;
            border: none;
            border-radius: 5px;
            background: linear-gradient(135deg, #007bff, #00d4ff);
            color: white;
            cursor: pointer;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);
        }
        .top-bar button:hover {
            background: linear-gradient(135deg, #0056b3, #009adf);
        }
        #loading {
            display: none;
            text-align: center;
            color: #00d4ff;
        }
#news-container {
    height: 100%;
    color: white;
    width: 100%;
    background: none;
    direction: rtl;
    display: inline-flex;
    flex-direction: row;
    flex-wrap: wrap;
}
.news-item {
    margin-bottom: 15px;
    padding: 10px;
    background: rgba(255, 255, 255, 0.1);
    border-radius: 8px;
    transition: transform 0.3s, background 0.3s;
}
.news-item:hover {
    transform: scale(1.03);
    background: rgba(255, 255, 255, 0.2);
}
.news-item h3 a {
    color: #1e90ff;
    text-decoration: none;
}
.news-item h3 a:hover {
    text-decoration: underline;
}
.news-item small {
    color: #ccc;
    font-size: 0.9rem;
}
.api-data-card {
    background: linear-gradient(135deg, #1e3a8a, #111827);
    border-radius: 10px;
    padding: 20px;
    color: #ffffff;
    box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);
    width: 100%;
}
.api-data-card:hover {
    transform: scale(1.03);
    box-shadow: 0 10px 20px rgba(0, 0, 0, 0.4);
}
.api-data-card p {
    margin: 5px 0;
}
.api-data-card .grid {
    display: grid;
    gap: 20px;
    grid-template-columns: repeat(auto-fit, minmax(200px, 1fr));
}
.api-data-card h3 {
    margin-bottom: 10px;
    color: #00d4ff;

}
.api-data-card .data-item {
    padding: 10px;
    border: 1px solid rgba(255, 255, 255, 0.2);
    border-radius: 8px;
    background-color: rgba(255, 255, 255, 0.05);
    text-align: center;
}
.api-data-card canvas {
    margin-top: 20px;
}
#api-results{
     height: 100%;
}

.text-3xl {
    font-size: 15px;
}
@media only screen and (max-width: 600px) {
.top-bar {
    position: absolute;
    top: 0;
    width: 100%;
    z-index: 10;
    padding: 10px;
    background: rgba(0, 0, 0, 0.8);
    display: flex;
    flex-wrap: wrap;
    justify-content: space-between;
    align-items: center;
    border-bottom: 1px solid rgba(255, 255, 255, 0.2);
  }
  .top-bar input, .top-bar select {
    width: 100%;
    }
    .autocomplete-suggestions {
    position: absolute;
    background: #2a2a2a;
    border-radius: 5px;
    z-index: 1000;
    width: 90%;
    max-height: 200px;
    overflow-y: auto;
    color: white;
    box-shadow: 0 0 9px 3px #007bff;
    background-color: #393939;
    margin-left: 0;
    line-height: 40px;
    padding-right: 10px;
    margin-top: -10px;
    margin-right: 8px;
}
body {
    background: linear-gradient(180deg, #1e3a8a, #111827);
    color: white;
    font-family: 'IRANSansWeb', Arial, sans-serif;
    direction: rtl;
    margin: 0;
    padding: 0;
    display: flex;
    background-repeat: no-repeat;
    flex-direction: column;
    flex-wrap: nowrap;

}
#top-section {
    height: 60vh;
    width: 97%;
    display: flex;
    flex-direction: row-reverse;
    align-items: center;
    justify-content: space-evenly;
    padding: 3px;
    box-sizing: border-box;
    margin-top: 250px;
    flex-wrap: wrap;
    align-content: stretch;
}
#bottom-section {
    height: 59.4vh;
    width: 97%;
    padding: 20px;
    box-sizing: border-box;
    margin-top: 20px;
    background: #121212;
    border-radius: 10px;
    overflow-y: scroll;
    margin-right: 4px;
    direction: rtl;
}
#btm-section {
    height: 55.7vh;
    width: 97%;
    display: flex;
    flex-direction: row-reverse;
    align-items: center;
    justify-content: space-evenly;
    padding: 20px;
    box-sizing: border-box;
    flex-wrap: wrap;
    align-content: stretch;
    background: #121212;
    border-radius: 10px;
    margin-bottom: 30px;
    overflow: hidden;
    margin-top: 25px;
}
.btm2-section {
    height: 55.7vh;
    width: 97%;
    padding: 20px;
    box-sizing: border-box;
    background: #121212;
    border-radius: 10px;
    margin-bottom: 30px;
    direction: rtl;
    overflow-y: scroll;
    margin-left: -5px;
}
}
.btm3-section {
    height: 55.7vh;
    width: 99%;
    padding: 20px;
    box-sizing: border-box;
    background: #121212;
    border-radius: 10px;
    margin-bottom: 30px;
    direction: rtl;
    margin-top: -26px;
    overflow-y: scroll;
}
  .btm3-section {
  --sb-track-color: #232E33;
  --sb-thumb-color: #0077bd;
  --sb-size: 6px;
}

.btm3-section::-webkit-scrollbar {
  width: var(--sb-size)
}

.btm3-section::-webkit-scrollbar-track {
  background: var(--sb-track-color);
  border-radius: 3px;
}

.btm3-section::-webkit-scrollbar-thumb {
  background: var(--sb-thumb-color);
  border-radius: 3px;
  border: 2px solid #0077bd;
}

@supports not selector(::-webkit-scrollbar) {
  .btm3-section {
    scrollbar-color: var(--sb-thumb-color)
                     var(--sb-track-color);
  }
}
.tabs {
    display: flex;
    justify-content: center;
    margin-bottom: 20px;
}

.tab-button {
    background: #007bff;
    color: white;
    border: none;
    padding: 10px 20px;
    margin: 0 10px;
    border-radius: 5px;
    cursor: pointer;
    transition: background 0.3s;
}

.tab-button.active {
    background: #0056b3;
}

.tab-button:hover {
    background: #0056b3;
}

.tab-content {
    display: none;
}

.tab-content.active {
    display: inline-flex;
    flex-direction: row;
    margin: 10px;
    flex-wrap: wrap;
    align-content: space-around;
    justify-content: center;
}
    .crypto-card {
      background: linear-gradient(145deg, #1e293b, #374151);
      box-shadow: 0 4px 6px rgba(0, 0, 0, 0.3), 0 -2px 4px rgba(0, 0, 0, 0.2);
      border-radius: 10px;
      padding: 10px;
      transition: transform 0.3s, box-shadow 0.3s;
    }
    .crypto-card:hover {
      transform: scale(1.05);
      box-shadow: 0 8px 15px rgba(0, 0, 0, 0.5);
    }
    .crypto-icon {
      width: 50px;
      height: 50px;
      border-radius: 50%;
      background-color: #2d3748;
      display: flex;
      align-items: center;
      justify-content: center;
      margin-bottom: 10px;
    }
    .crypto-icon img {
      width: 80%;
    }
    .card-chart {
      height: 50px;
      background-color: #2d3748;
      border-radius: 10px;
      margin-top: 10px;
    }
    .search-bar {
      margin-bottom: 20px;
    }
    .pagination {
      display: flex;
      justify-content: center;
      gap: 10px;
      margin-top: 20px;
    }
    .pagination button {
      background: #374151;
      color: white;
      border-radius: 5px;
      padding: 5px 10px;
    }
    .pagination button.active {
      background: #1e293b;
      font-weight: bold;
    }
.p-4{
    padding: 1rem;
    width: 300px;
    margin-left: 10px;
    margin-bottom: 10px;
}
    </style>
</head>
<body>
    <!-- Top Bar -->
    <div class="top-bar">
        <h3>نام ارز خود را وارد کنید</h3>
        <input id="currencyInput" type="text" placeholder="(ETH, BTC)" />
        <h3>مدت زمان پوزیشن</h3>
        <select id="intervalSelect">
            <option value="30m">30 دقیقه‌ای</option>
            <option value="1h">1 ساعته</option>
            <option value="2h">2 ساعته</option>
            <option value="4h">4 ساعته</option>
            <option value="8h">8 ساعته</option>
            <option value="1d">1 روزه</option>
        </select>
        <button id="loadChart">تحلیل ارز</button>
        <div id="autocomplete-suggestions" class="autocomplete-suggestions hidden"></div>
    </div>

    <!-- Top Section (Chart) -->
    <div id="top-section">
        <div id="tradingview-widget">
        <h2 class="section-title text-2xl font-extrabold text-center mb-4"style="margin-top: 15px;">چارت ارز</h2>
        </div>
    </div>

<!-- Bottom Section -->
<div id="bottom-section">
    <h2 class="section-title text-2xl font-extrabold text-center mb-4">نتایج معامله‌گر</h2>
    <div class="tabs">
        <button class="tab-button active" data-tab="basic">Basic Traders</button>
        <button class="tab-button" data-tab="plus">Plus Traders</button>
        <button class="tab-button" data-tab="pro">Pro Traders</button>
    </div>
    <div id="loading-basic" class="loading-message">در حال بارگذاری داده‌های Basic...</div>
    <div id="loading-plus" class="loading-message hidden">در حال بارگذاری داده‌های Plus...</div>
    <div id="loading-pro" class="loading-message hidden">در حال بارگذاری داده‌های Pro...</div>

    <div class="tab-content active" id="results-basic">
        <p>در حال حاضر هیچ داده‌ای بارگذاری نشده است.</p>
    </div>
    <div class="tab-content hidden" id="results-plus">
        <p>در حال حاضر هیچ داده‌ای بارگذاری نشده است.</p>
    </div>
    <div class="tab-content hidden" id="results-pro">
        <p>در حال حاضر هیچ داده‌ای بارگذاری نشده است.</p>
    </div>
</div>
    <div id="btm-section">
        <h2 class="section-title text-2xl font-extrabold text-center mb-4">اخبار مرتبط با ارز</h2>
        <div id="news-container" class="overflow-y-auto p-4 bg-gray-900 rounded-lg">
         <p>بعد از انتخاب ارز اخبار مربوطه نمایش داده میشود</p>
        </div>
    </div>
<div class="btm2-section">
    <h2 class="section-title text-2xl font-extrabold text-center mb-4">داده‌های مربوط به ارز</h2>
    <div id="api-section" class="p-6">
        <div id="api-results" class="grid grid-cols-1 gap-6"></div>
    </div>
</div>
<div class="btm3-section">
    <h2 class="section-title text-2xl font-extrabold text-center mb-4">روند کل بازار</h2>
  <input
    id="searchBar"
    type="text"
    placeholder="Search for a cryptocurrency"
    class="w-full p-3 mb-4 rounded-lg shadow-md focus:outline-none"
  />

  <div id="cryptoCards" class="grid grid-cols-1 sm:grid-cols-2 md:grid-cols-3 lg:grid-cols-4 gap-4"></div>

  <div id="pagination" class="mt-6 flex justify-center"></div>




</div>
    <script>
// Fetch Binance Pairs
async function fetchTradingPairs() {
    const apiUrl = 'https://api.binance.com/api/v3/exchangeInfo';
    const response = await fetch(apiUrl);
    const data = await response.json();

    // Filter symbols that end with USDT and exclude derivatives like UP/DOWN
    return data.symbols
        .filter(symbolInfo => 
            symbolInfo.symbol.endsWith('USDT') &&
            !symbolInfo.symbol.includes('UP') &&
            !symbolInfo.symbol.includes('DOWN') &&
            !symbolInfo.symbol.includes('ST')
        )
        .map(symbolInfo => symbolInfo.baseAsset);
}

// AutoComplete
let tradingPairs = [];
fetchTradingPairs().then(pairs => tradingPairs = pairs);

$(document).ready(function () {
    $('#currencyInput').on('input', function () {
        const query = $(this).val().toUpperCase();
        if (query.length >= 2) {
            const suggestions = tradingPairs.filter(pair => pair.startsWith(query));
            const suggestionsBox = $('#autocomplete-suggestions');
            if (suggestions.length > 0) {
                suggestionsBox.html(suggestions.map(pair => `<div>${pair}</div>`).join('')).removeClass('hidden');
            } else {
                suggestionsBox.addClass('hidden');
            }
        } else {
            $('#autocomplete-suggestions').addClass('hidden');
        }
    });

    $(document).on('click', '.autocomplete-suggestions div', function () {
        $('#currencyInput').val($(this).text());
        $('#autocomplete-suggestions').addClass('hidden');
    });
});
async function fetchGoogleNews(symbol) {
    const query = `${symbol} cryptocurrency`;
    const rssUrl = `https://news.google.com/rss/search?q=${encodeURIComponent(query)}&hl=en-US&gl=US&ceid=US:en`;

    try {
        console.log('Fetching news for RSS URL:', rssUrl);

        const apiUrl = `https://api.rss2json.com/v1/api.json?rss_url=${encodeURIComponent(rssUrl)}`;
        const response = await fetch(apiUrl);
        const data = await response.json();

        console.log('API Response:', data);
        if (data.status === 'error') {
            throw new Error(data.message);
        }

        const newsContainer = document.getElementById('news-container');
        newsContainer.innerHTML = '';

        const now = new Date();
        const threeDaysAgo = new Date(now.getTime() - (3 * 24 * 60 * 60 * 1000));

        const filteredNews = data.items.filter(news => new Date(news.pubDate) > threeDaysAgo);

        if (filteredNews.length > 0) {
            filteredNews.slice(0, 50).forEach(news => {
                const title = news.title || "عنوان نامشخص";
                const contentSnippet = news.contentSnippet || "برای مطالعه بیشتر به لینک زیر مراجعه کنید.";
                const pubDate = news.pubDate ? new Date(news.pubDate).toLocaleString('fa-IR') : "تاریخ موجود نیست";
                const link = news.link || "#";

                newsContainer.innerHTML += `
                    <div class="news-item bg-gray-800 p-4 rounded shadow mb-4">
                        <h3 class="text-lg font-bold mb-2"><a href="${link}" target="_blank">${title}</a></h3>
                        <p>${contentSnippet}</p>
                        <small>تاریخ انتشار: ${pubDate}</small>
                    </div>
                `;
            });
        } else {
            newsContainer.innerHTML = '<p>هیچ خبری برای این ارز در 3 روز گذشته یافت نشد.</p>';
        }
    } catch (error) {
        console.error('Error fetching news:', error.message);
        document.getElementById('news-container').innerHTML = `<p>خطا: ${error.message}</p>`;
    }
}

let allAssets = [];

// دریافت لیست تمامی ارزها از CoinCap API
async function fetchAllAssets() {
    const apiUrl = "https://api.coincap.io/v2/assets";
    try {
        const response = await fetch(apiUrl);
        if (!response.ok) throw new Error("خطا در دریافت فهرست ارزها از CoinCap API");

        const data = await response.json();
        allAssets = data.data;
    } catch (error) {
        console.error("CoinCap Asset List Error:", error.message);
    }
}

// تطبیق symbol کاربر با شناسه CoinCap
function findAssetId(symbol) {
    const asset = allAssets.find(item => item.symbol.toLowerCase() === symbol.toLowerCase());
    return asset ? asset.id : null;
}

// دریافت اطلاعات ارز از CoinCap API
async function fetchCoinCapData(symbol) {
    const apiKey = "3e3d1672-fd99-4b35-b5b2-ce3895f6dfc9";

    // پیدا کردن شناسه مرتبط با symbol
    const assetId = findAssetId(symbol);
    if (!assetId) {
        document.getElementById("api-results").innerHTML = `
            <div class="api-data-card">
                <p>ارز مورد نظر در CoinCap موجود نیست.</p>
            </div>
        `;
        return;
    }

    const url = `https://api.coincap.io/v2/assets/${assetId}`;

    try {
        const response = await fetch(url, {
            headers: {
                Authorization: `Bearer ${apiKey}`,
            },
        });

        if (!response.ok) {
            throw new Error("خطا در دریافت داده‌ها از CoinCap API");
        }

        const data = await response.json();
        displayCoinCapData(data.data);
    } catch (error) {
        console.error("CoinCap API Error:", error.message);
        document.getElementById("api-results").innerHTML = `
            <div class="api-data-card">
                <p>خطا در دریافت داده‌ها. لطفاً مجدداً تلاش کنید.</p>
            </div>
        `;
    }
}


function displayCoinCapData(data) {
    const container = document.getElementById("api-results");
    container.innerHTML = `
        <div class="api-data-card p-8 rounded-lg shadow-xl bg-gradient-to-r from-blue-800 via-blue-900 to-gray-900 text-white">
            <div class="flex items-center justify-between mb-6">
                <h3 class="text-4xl font-bold">${data.name} (${data.symbol})</h3>
                <span class="text-sm bg-yellow-500 px-4 py-2 rounded-lg shadow">رتبه: ${data.rank}</span>
            </div>
            <div class="grid grid-cols-2 md:grid-cols-3 lg:grid-cols-4 gap-6">
                <div class="data-item">
                    <p class="text-sm text-gray-400">قیمت فعلی:</p>
                    <p class="text-3xl font-extrabold text-green-400">$${parseFloat(data.priceUsd).toFixed(2)}</p>
                </div>
                <div class="data-item">
                    <p class="text-sm text-gray-400">مارکت کپ:</p>
                    <p class="text-3xl font-extrabold">$${parseFloat(data.marketCapUsd).toLocaleString()}</p>
                </div>
                <div class="data-item">
                    <p class="text-sm text-gray-400">عرضه در گردش:</p>
                    <p class="text-xl font-bold">${parseFloat(data.supply).toLocaleString()} ${data.symbol}</p>
                </div>
                <div class="data-item">
                    <p class="text-sm text-gray-400">عرضه کل:</p>
                    <p class="text-xl font-bold">${parseFloat(data.maxSupply || 0).toLocaleString()} ${data.symbol}</p>
                </div>
                <div class="data-item">
                    <p class="text-sm text-gray-400">حجم معاملات 24 ساعته:</p>
                    <p class="text-3xl font-extrabold text-blue-400">$${parseFloat(data.volumeUsd24Hr).toLocaleString()}</p>
                </div>
                <div class="data-item">
                    <p class="text-sm text-gray-400">تغییرات 24 ساعته:</p>
                    <p class="text-3xl font-extrabold ${parseFloat(data.changePercent24Hr) >= 0 ? 'text-green-400' : 'text-red-400'}">
                        ${parseFloat(data.changePercent24Hr).toFixed(2)}%
                    </p>
                </div>
                <div class="data-item">
                    <p class="text-sm text-gray-400">بالاترین قیمت روز:</p>
                    <p class="text-2xl font-bold">$${parseFloat(data.highUsd || 0).toFixed(2)}</p>
                </div>
                <div class="data-item">
                    <p class="text-sm text-gray-400">پایین‌ترین قیمت روز:</p>
                    <p class="text-2xl font-bold">$${parseFloat(data.lowUsd || 0).toFixed(2)}</p>
                </div>
            </div>
            <div class="mt-6">
                <h4 class="text-lg font-bold">نمودار قیمت 24 ساعته:</h4>
                <canvas id="price-chart" width="400" height="100"></canvas>
            </div>
        </div>
    `;

    renderPriceChart(data.id);
}

async function renderPriceChart(assetId) {
    const url = `https://api.coincap.io/v2/assets/${assetId}/history?interval=h1`;
    try {
        const response = await fetch(url);
        const data = await response.json();

        const prices = data.data.map(point => parseFloat(point.priceUsd));
        const timestamps = data.data.map(point =>
            new Date(point.time).toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })
        );

        const ctx = document.getElementById("price-chart").getContext("2d");

        // حذف نمودار قبلی (اگر موجود باشد)
        if (window.myChart) {
            window.myChart.destroy();
        }

        // ایجاد نمودار جدید
        window.myChart = new Chart(ctx, {
            type: 'line',
            data: {
                labels: timestamps,
                datasets: [{
                    label: 'Price (USD)',
                    data: prices,
                    borderColor: 'rgba(75, 192, 192, 1)',
                    backgroundColor: 'rgba(75, 192, 192, 0.2)',
                    borderWidth: 2,
                    tension: 0.3,
                }],
            },
            options: {
                responsive: true,
                plugins: {
                    legend: {
                        display: false,
                    },
                },
                scales: {
                    x: {
                        ticks: {
                            maxTicksLimit: 12, // تعداد محدود تیک‌ها برای محور x
                        },
                    },
                    y: {
                        beginAtZero: false,
                    },
                },
            },
        });
    } catch (error) {
        console.error("Chart Error:", error.message);
    }
}
// دریافت داده‌های تاریخی ارز
async function fetchHistoricalData(symbol) {
    const apiUrl = `https://api.coincap.io/v2/assets/${symbol}/history?interval=d1`;
    try {
        const response = await fetch(apiUrl);
        if (!response.ok) throw new Error("خطا در دریافت داده‌های تاریخی");

        const data = await response.json();
        displayHistoricalData(data.data);
    } catch (error) {
        console.error("Historical Data Error:", error.message);
    }
}

// نمایش داده‌های تاریخی
function displayHistoricalData(data) {
    const container = document.getElementById("api-results");
    const historicalContainer = document.createElement("div");
    historicalContainer.classList.add("historical-data");

    historicalContainer.innerHTML = `
        <h3>داده‌های تاریخی:</h3>
        <ul>
            ${data.slice(-7).map(day => `
                <li>${day.date}: $${parseFloat(day.priceUsd).toFixed(2)}</li>
            `).join("")}
        </ul>
    `;
    container.appendChild(historicalContainer);
}

// درخواست لیست دارایی‌ها در هنگام بارگذاری صفحه
fetchAllAssets();

// دریافت اطلاعات ارز کاربر هنگام کلیک روی "Load Chart"
$('#loadChart').on('click', async function () {
    const symbol = $('#currencyInput').val().toUpperCase();
    if (!symbol) return alert('لطفاً نام ارز خود را وارد کنید.');

    fetchCoinCapData(symbol);
});


// Manage tabs
$('.tab-button').on('click', function () {
    const selectedTab = $(this).data('tab');

    // Update active tab button
    $('.tab-button').removeClass('active');
    $(this).addClass('active');

    // Show related content and hide others
    $('.tab-content').removeClass('active').addClass('hidden');
    $(`#results-${selectedTab}`).removeClass('hidden').addClass('active');

    // Show the loading message for the selected tab if needed
    $('.loading-message').addClass('hidden');
    $(`#loading-${selectedTab}`).removeClass('hidden');
});

// Load TradingView Chart
$('#loadChart').on('click', async function () {
    const symbol = $('#currencyInput').val().toUpperCase();
    const interval = $('#intervalSelect').val();

    if (!symbol) return alert('لطفا یک نماد ارز دیجیتال معتبر وارد کنید!');
    if (!interval) return alert('لطفاً یک فاصله زمانی معتبر انتخاب کنید!');

    fetchGoogleNews(symbol);
    fetchCoinCapData(symbol);

    $('#tradingview-widget').html('');

    new TradingView.widget({
        container_id: "tradingview-widget",
        symbol: `BINANCE:${symbol}USDT`,
        interval: "15",
        theme: "dark",
        style: "1",
        locale: "en",
        toolbar_bg: "#121212",
        hide_side_toolbar: true,
        details: true,
        autosize: true,
        width: "100%",
        height: "550px",
    });

    ['basic', 'plus', 'pro'].forEach(type => {
        fetchAndDisplayTraders(type, symbol, interval);
    });

//bazar
const cardsPerPage = 24; // تعداد کارت‌ها در هر صفحه
let cryptoData = []; // آرایه‌ای برای داده‌های رمز ارزها
let currentPage = 1; // شماره صفحه فعلی
let cardElements = {}; // ذخیره عناصر کارت‌ها برای به‌روزرسانی

// ایجاد اتصال WebSocket
function initWebSocket() {
  const socket = new WebSocket('wss://stream.binance.com:9443/ws/!ticker@arr');

  socket.onmessage = (event) => {
    const liveData = JSON.parse(event.data);

    // مرتب‌سازی داده‌ها بر اساس رنکینگ (قیمت لحظه‌ای یا هر پارامتر دلخواه)
    cryptoData = liveData.sort((a, b) => parseFloat(b.q) - parseFloat(a.q));

    // اگر کارت‌ها قبلاً ایجاد نشده‌اند، کارت‌ها را رندر کنید
    if (Object.keys(cardElements).length === 0) {
      renderCards();
      renderPagination();
    }

    // به‌روزرسانی داده‌های کارت‌ها
    updateCards();
  };

  socket.onclose = () => {
    console.error('WebSocket connection closed. Retrying...');
    setTimeout(initWebSocket, 1000); // تلاش مجدد برای اتصال
  };

  socket.onerror = (error) => {
    console.error('WebSocket error:', error);
  };
}

// ایجاد کارت‌ها فقط یک بار
function renderCards() {
  const container = document.getElementById('cryptoCards');
  container.innerHTML = ''; // پاک کردن کارت‌های قبلی

  const start = (currentPage - 1) * cardsPerPage;
  const end = start + cardsPerPage;

  // انتخاب داده‌های صفحه فعلی
  const paginatedData = cryptoData.slice(start, end);

  paginatedData.forEach((coin) => {
    const card = document.createElement('div');
    card.className =
      'crypto-card p-4 bg-gray-800 rounded-lg shadow-md flex flex-col items-center';

    card.innerHTML = `
      <div class="crypto-icon mb-4">
        <img src="https://raw.githubusercontent.com/spothq/cryptocurrency-icons/master/128/color/${coin.s
          .slice(0, 3)
          .toLowerCase()}.png" alt="${coin.s}" onerror="this.src='https://via.placeholder.com/50'" class="w-12 h-12">
      </div>
      <h2 class="text-center text-lg font-bold text-white">${coin.s}</h2>
      <p class="price text-center text-sm text-white">$${parseFloat(coin.c).toFixed(2)}</p>
      <p class="change text-center text-sm text-green-500">${parseFloat(coin.P).toFixed(2)}%</p>
      <p class="volume text-center text-sm text-gray-400">Volume: ${parseFloat(
        coin.q
      ).toLocaleString()}</p>
    `;

    container.appendChild(card);

    // ذخیره عنصر کارت برای به‌روزرسانی بعدی
    cardElements[coin.s] = {
      card,
      price: card.querySelector('.price'),
      change: card.querySelector('.change'),
      volume: card.querySelector('.volume'),
    };
  });
}

// به‌روزرسانی داده‌های کارت‌ها
function updateCards() {
  const start = (currentPage - 1) * cardsPerPage;
  const end = start + cardsPerPage;

  const paginatedData = cryptoData.slice(start, end);

  paginatedData.forEach((coin) => {
    const elements = cardElements[coin.s];
    if (elements) {
      elements.price.textContent = `$${parseFloat(coin.c).toFixed(2)}`;
      elements.change.textContent = `${parseFloat(coin.P).toFixed(2)}%`;
      elements.volume.textContent = `Volume: ${parseFloat(coin.q).toLocaleString()}`;
      elements.change.className = `change text-center text-sm ${
        parseFloat(coin.P) > 0 ? 'text-green-500' : 'text-red-500'
      }`;
    }
  });
}

// رندر صفحه‌بندی
function renderPagination() {
  const totalPages = Math.ceil(cryptoData.length / cardsPerPage);
  const paginationContainer = document.getElementById('pagination');
  paginationContainer.innerHTML = ''; // پاک کردن دکمه‌های قبلی

  for (let i = 1; i <= totalPages; i++) {
    const button = document.createElement('button');
    button.textContent = i;
    button.className = `px-4 py-2 mx-1 rounded-lg ${
      i === currentPage ? 'bg-blue-600 text-white' : 'bg-gray-700 text-white'
    }`;

    button.addEventListener('click', () => {
      currentPage = i;
      renderCards(); // ایجاد کارت‌ها برای صفحه جدید
    });
    paginationContainer.appendChild(button);
  }
}

// جستجوی رمز ارز
document.getElementById('searchBar').addEventListener('input', function (e) {
  const query = e.target.value.toLowerCase();

  // فیلتر داده‌ها بر اساس جستجو
  const filteredData = cryptoData.filter((coin) =>
    coin.s.toLowerCase().includes(query)
  );

  currentPage = 1; // بازگشت به صفحه اول
  cryptoData = filteredData;
  renderCards();
  renderPagination();
});

// راه‌اندازی WebSocket
initWebSocket();


});

// Fetch and display traders for each type
async function fetchAndDisplayTraders(type, symbol, interval) {
    const endpointMap = {
        basic: "basic_traders.php",
        plus: "plus_traders.php",
        pro: "pro_traders.php",
    };

    const endpoint = endpointMap[type];
    const resultsContainer = $(`#results-${type}`);
    const loadingMessage = $(`#loading-${type}`);

    try {
        loadingMessage.show();
        resultsContainer.html('');

        const response = await fetch(`${endpoint}?symbol=${symbol}USDT&interval=${interval}`);
        const traders = await response.json();

        loadingMessage.hide();

        traders.forEach((trader, index) => {
            const cardColor = trader.trend === 'صعودی' ? 'bg-green-800' : 'bg-red-800';

            resultsContainer.append(`
                <div class="${cardColor} p-4 rounded shadow">
                    <h3 class="text-lg font-bold mb-2">${trader.name} (${type.toUpperCase()})</h3>
                    <p><strong>Trend:</strong> ${trader.trend}</p>
                    <p><strong>Reason:</strong> ${trader.reason}</p>
                    <p><strong>UTC Time:</strong> ${trader.utcTime}</p>
                    <p><strong>Tehran Time:</strong> ${trader.tehranTime}</p>
                </div>
            `);
        });
    } catch (error) {
        loadingMessage.hide();
        resultsContainer.html(`<p>Error fetching ${type} traders: ${error.message}</p>`);
    }
}

</script>
    <script src="https://s3.tradingview.com/tv.js"></script>
</body>
<style>
.bg-green-800{
    background-color: #214d22;
    background-image: linear-gradient(65deg, rgba(255, 255, 255, 0.02) 40%, transparent 40%);
    border-radius: 3px;
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.3);   
}
.bg-red-800{
    background-color: #751a1a;
    background-image: linear-gradient(65deg, rgba(255, 255, 255, 0.02) 40%, transparent 40%);
    border-radius: 3px;
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.3);
}
</style>
</html>
